<cfscript>
/*
	Name         : SQL color Coder
	Author       : Brad Wood
	Created      : August 19th, 2007
	Last Updated : August 20th, 2007
	History      : Initial Coding (bdw)
	Purpose		 : Add markup to a sql string to color code it like MS Query Analyzer
*/

	function sql_color_code(sql_string)
		{
			// These are according to MS SQL Server
			color_definition = structnew();
			color_definition["Character string"]  = "Red";
 			color_definition["Stored Procedure"] = '##AF0000'; // Dark Red
			color_definition["System Table"] = 'Green';
			color_definition["Comment"] = '##008000'; // Dark Green
			color_definition["System Function"] = 'Magenta';
			color_definition["Keyword"] = 'Blue';
			color_definition["Operator"] = 'Gray';
			
			// Most of these lists came off the MSDN articles I pulled up with Google
			operator_list = "!|,|.|/|*|-|+|<|>|(|)|=";
			reserved_word_list = "OUTPUT|ADD|EXCEPT|PERCENT|ALL|EXEC|PLAN|ALTER|EXECUTE|PRECISION|AND|EXISTS|PRIMARY|ANY|EXIT|PRINT|AS|FETCH|PROC|ASC|FILE|PROCEDURE|AUTHORIZATION|FILLFACTOR|PUBLIC|BACKUP|FOR|RAISERROR|BEGIN|FOREIGN|READ|BETWEEN|FREETEXT|READTEXT|BREAK|FREETEXTTABLE|RECONFIGURE|BROWSE|FROM|REFERENCES|BULK|FULL|REPLICATION|BY|FUNCTION|RESTORE|CASCADE|GOTO|RESTRICT|CASE|GRANT|RETURN|CHECK|GROUP|REVOKE|CHECKPOINT|HAVING|RIGHT|CLOSE|HOLDLOCK|ROLLBACK|CLUSTERED|IDENTITY|ROWCOUNT|COALESCE|IDENTITY_INSERT|ROWGUIDCOL|COLLATE|IDENTITYCOL|RULE|COLUMN|IF|SAVE|COMMIT|IN|SCHEMA|COMPUTE|INDEX|SELECT|CONSTRAINT|INNER|SESSION_USER|CONTAINS|INSERT|SET|CONTAINSTABLE|INTERSECT|SETUSER|CONTINUE|INTO|SHUTDOWN|CONVERT|IS|SOME|CREATE|JOIN|STATISTICS|CROSS|KEY|SYSTEM_USER|CURRENT|KILL|TABLE|CURRENT_DATE|LEFT|TEXTSIZE|CURRENT_TIME|LIKE|THEN|CURRENT_TIMESTAMP|LINENO|TO|CURRENT_USER|LOAD|TOP|CURSOR|NATIONAL|TRAN|DATABASE|NOCHECK|TRANSACTION|DBCC|NONCLUSTERED|TRIGGER|DEALLOCATE|NOT|TRUNCATE|DECLARE|NULL|TSEQUAL|DEFAULT|NULLIF|UNION|DELETE|OF|UNIQUE|DENY|OFF|UPDATE|DESC|OFFSETS|UPDATETEXT|DISK|ON|USE|DISTINCT|OPEN|USER|DISTRIBUTED|OPENDATASOURCE|VALUES|DOUBLE|OPENQUERY|VARYING|DROP|OPENROWSET|VIEW|DUMMY|OPENXML|WAITFOR|DUMP|OPTION|WHEN|ELSE|OR|WHERE|END|ORDER|WHILE|ERRLVL|OUTER|WITH|ESCAPE|OVER|WRITETEXT";
			system_stored_proc_list = "sp_ActiveDirectory_Obj|sp_ActiveDirectory_SCP|sp_column_privileges|sp_special_columns|sp_columns|sp_sproc_columns|sp_databases|sp_statistics|sp_fkeys|sp_stored_procedures|sp_pkeys|sp_table_privileges|sp_server_info|sp_tables|sp_cursor_list|sp_describe_cursor_columns|sp_describe_cursor|sp_describe_cursor_tables|sp_add_maintenance_plan|sp_delete_maintenance_plan_db|sp_add_maintenance_plan_db|sp_delete_maintenance_plan_job|sp_add_maintenance_plan_job|sp_help_maintenance_plan|sp_delete_maintenance_plan|sp_addlinkedserver|sp_indexes|sp_addlinkedsrvlogin|sp_linkedservers|sp_catalogs|sp_primarykeys|sp_column_privileges_ex|sp_serveroption|sp_columns_ex|sp_table_privileges_ex|sp_droplinkedsrvlogin|sp_tables_ex|sp_foreignkeys|sp_fulltext_catalog|sp_help_fulltext_catalogs_cursor|sp_fulltext_column|sp_help_fulltext_columns|sp_fulltext_database|sp_help_fulltext_columns_cursor|sp_fulltext_service|sp_help_fulltext_tables|sp_fulltext_table|sp_help_fulltext_tables_cursor|sp_help_fulltext_catalogs|sp_add_log_shipping_database|sp_delete_log_shipping_database|sp_add_log_shipping_plan|sp_delete_log_shipping_plan|sp_add_log_shipping_plan_database|sp_delete_log_shipping_plan_database|sp_add_log_shipping_primary|sp_delete_log_shipping_primary|sp_add_log_shipping_secondary|sp_delete_log_shipping_secondary|sp_can_tlog_be_applied|sp_get_log_shipping_monitor_info|sp_change_monitor_role|sp_remove_log_shipping_monitor|sp_change_primary_role|sp_resolve_logins|sp_change_secondary_role|sp_update_log_shipping_monitor_info|sp_create_log_shipping_monitor_account|sp_update_log_shipping_plan|sp_define_log_shipping_monitor|sp_update_log_shipping_plan_database|sp_OACreate|sp_OAMethod|sp_OADestroy|sp_OASetProperty|sp_OAGetErrorInfo|sp_OAStop|sp_OAGetPropertyObjectHierarchySyntax|sp_add_agent_parameter|sp_enableagentoffload|sp_add_agent_profile|sp_enumcustomresolvers|sp_addarticle|sp_enumdsn|sp_adddistpublisher|sp_enumfullsubscribers|sp_adddistributiondb|sp_expired_subscription_cleanup|sp_adddistributor|sp_generatefilters|sp_addmergealternatepublisher|sp_getagentoffloadinfo|sp_addmergearticle|sp_getmergedeletetype|sp_addmergefilter|sp_get_distributor|sp_addmergepublication|sp_getqueuedrows|sp_addmergepullsubscription|sp_getsubscriptiondtspackagename|sp_addmergepullsubscription_agent|sp_grant_publication_access|sp_addmergesubscription|sp_help_agent_default|sp_addpublication|sp_help_agent_parameter|sp_addpublication_snapshot|sp_help_agent_profile|sp_addpublisher70|sp_helparticle|sp_addpullsubscription|sp_helparticlecolumns|sp_addpullsubscription_agent|sp_helparticledts|sp_addscriptexec|sp_helpdistpublisher|sp_addsubscriber|sp_helpdistributiondb|sp_addsubscriber_schedule|sp_helpdistributor|sp_addsubscription|sp_helpmergealternatepublisher|sp_addsynctriggers|sp_helpmergearticle|sp_addtabletocontents|sp_helpmergearticlecolumn|sp_adjustpublisheridentityrange|sp_helpmergearticleconflicts|sp_article_validation|sp_helpmergeconflictrows|sp_articlecolumn|sp_helpmergedeleteconflictrows|sp_articlefilter|sp_helpmergefilter|sp_articlesynctranprocs|sp_helpmergepublication|sp_articleview|sp_helpmergepullsubscription|sp_attachsubscription|sp_helpmergesubscription|sp_browsesnapshotfolder|sp_helppublication|sp_browsemergesnapshotfolder|sp_help_publication_access|sp_browsereplcmds|sp_helppullsubscription|sp_change_agent_parameter|sp_helpreplfailovermode|sp_change_agent_profile|sp_helpreplicationdboption|sp_changearticle|sp_helpreplicationoption|sp_changedistpublisher|sp_helpsubscriberinfo|sp_changedistributiondb|sp_helpsubscription|sp_changedistributor_password|sp_helpsubscription_properties|sp_changedistributor_property|sp_ivindexhasnullcols|sp_changemergearticle|sp_link_publication|sp_changemergefilter|sp_marksubscriptionvalidation|sp_changemergepublication|sp_mergearticlecolumn|sp_changemergepullsubscription|sp_mergecleanupmetadata|sp_changemergesubscription|sp_mergedummyupdate|sp_changepublication|sp_mergesubscription_cleanup|sp_changesubscriber|sp_publication_validation|sp_changesubscriber_schedule|sp_refreshsubscriptions|sp_changesubscriptiondtsinfo|sp_reinitmergepullsubscription|sp_changesubstatus|sp_reinitmergesubscription|sp_change_subscription_properties|sp_reinitpullsubscription|sp_check_for_sync_trigger|sp_reinitsubscription|sp_copymergesnapshot|sp_removedbreplication|sp_copysnapshot|sp_repladdcolumn|sp_copysubscription|sp_replcmds|sp_deletemergeconflictrow|sp_replcounters|sp_disableagentoffload|sp_repldone|sp_drop_agent_parameter|sp_repldropcolumn|sp_drop_agent_profile|sp_replflush|sp_droparticle|sp_replicationdboption|sp_dropanonymouseagent|sp_replication_agent_checkup|sp_dropdistpublisher|sp_replqueuemonitor|sp_dropdistributiondb|sp_replsetoriginator|sp_dropmergealternatepublisher|sp_replshowcmds|sp_dropdistributor|sp_repltrans|sp_dropmergearticle|sp_restoredbreplication|sp_dropmergefilter|sp_resyncmergesubscription|sp_revoke_publication_access|sp_dropmergepublication|sp_scriptsubconflicttable|sp_dropmergepullsubscription|sp_script_synctran_commands|sp_setreplfailovermode|sp_dropmergesubscription|sp_showrowreplicainfo|sp_droppublication|sp_subscription_cleanup|sp_droppullsubscription|sp_table_validation|sp_dropsubscriber|sp_update_agent_profile|sp_dropsubscription|sp_validatemergepublication|sp_dsninfo|sp_validatemergesubscription|sp_dumpparamcmd|sp_vupgrade_replication|sp_addalias|sp_droprolemember|sp_addapprole|sp_dropserver|sp_addgroup|sp_dropsrvrolemember|sp_addlinkedsrvlogin|sp_dropuser|sp_addlogin|sp_grantdbaccess|sp_addremotelogin|sp_grantlogin|sp_addrole|sp_helpdbfixedrole|sp_addrolemember|sp_helpgroup|sp_addserver|sp_helplinkedsrvlogin|sp_addsrvrolemember|sp_helplogins|sp_adduser|sp_helpntgroup|sp_approlepassword|sp_helpremotelogin|sp_changedbowner|sp_helprole|sp_changegroup|sp_helprolemember|sp_changeobjectowner|sp_helprotect|sp_change_users_login|sp_helpsrvrole|sp_dbfixedrolepermission|sp_helpsrvrolemember|sp_defaultdb|sp_helpuser|sp_defaultlanguage|sp_MShasdbaccess|sp_denylogin|sp_password|sp_dropalias|sp_remoteoption|sp_dropapprole|sp_revokedbaccess|sp_dropgroup|sp_revokelogin|sp_droplinkedsrvlogin|sp_setapprole|sp_droplogin|sp_srvrolepermission|sp_dropremotelogin|sp_validatelogins|sp_droprole|sp_processmail|xp_sendmail|xp_deletemail|xp_startmail|xp_findnextmsg|xp_stopmail|xp_readmail|sp_trace_create|sp_trace_setfilter|sp_trace_generateevent|sp_trace_setstatus|sp_trace_setevent|sp_add_alert|sp_help_jobhistory|sp_add_category|sp_help_jobschedule|sp_add_job|sp_help_jobserver|sp_add_jobschedule|sp_help_jobstep|sp_add_jobserver|sp_help_notification|sp_add_jobstep|sp_help_operator|sp_add_notification|sp_help_targetserver|sp_add_operator|sp_help_targetservergroup|sp_add_targetservergroup|sp_helptask|sp_add_targetsvrgrp_member|sp_manage_jobs_by_login|sp_addtask|sp_msx_defect|sp_apply_job_to_targets|sp_msx_enlist|sp_delete_alert|sp_post_msx_operation|sp_delete_category|sp_purgehistory|sp_delete_job|sp_purge_jobhistory|sp_delete_jobschedule|sp_reassigntask|sp_delete_jobserver|sp_remove_job_from_targets|sp_delete_jobstep|sp_resync_targetserver|sp_delete_notification|sp_start_job|sp_delete_operator|sp_stop_job|sp_delete_targetserver|sp_update_alert|sp_delete_targetservergroup|sp_update_category|sp_delete_targetsvrgrp_member|sp_update_job|sp_droptask|sp_update_jobschedule|sp_help_alert|sp_update_jobstep|sp_help_category|sp_update_notification|sp_help_downloadlist|sp_update_operator|sp_helphistory|sp_update_targetservergroup|sp_help_job|sp_updatetask|xp_sqlagent_proxy_account|sp_add_data_file_recover_suspect_db|sp_helpconstraint|sp_addextendedproc|sp_helpdb|sp_addextendedproperty|sp_helpdevice|sp_add_log_file_recover_suspect_db|sp_helpextendedproc|sp_addmessage|sp_helpfile|sp_addtype|sp_helpfilegroup|sp_addumpdevice|sp_helpindex|sp_altermessage|sp_helplanguage|sp_autostats|sp_helpserver|sp_attach_db|sp_helpsort|sp_attach_single_file_db|sp_helpstats|sp_bindefault|sp_helptext|sp_bindrule|sp_helptrigger|sp_bindsession|sp_indexoption|sp_certify_removable|sp_invalidate_textptr|sp_configure|sp_lock|sp_create_removable|sp_monitor|sp_createstats|sp_procoption|sp_cycle_errorlog|sp_recompile|sp_datatype_info|sp_refreshview|sp_dbcmptlevel|sp_releaseapplock|sp_dboption|sp_rename|sp_dbremove|sp_renamedb|sp_delete_backuphistory|sp_resetstatus|sp_depends|sp_serveroption|sp_detach_db|sp_setnetname|sp_dropdevice|sp_settriggerorder|sp_dropextendedproc|sp_spaceused|sp_dropextendedproperty|sp_tableoption|sp_dropmessage|sp_unbindefault|sp_droptype|sp_unbindrule|sp_executesql|sp_updateextendedproperty|sp_getapplock|sp_updatestats|sp_getbindtoken|sp_validname|sp_help|sp_who|sp_dropwebtask|sp_makewebtask|sp_enumcodepages|sp_runwebtask|sp_xml_preparedocument|sp_xml_removedocument|xp_cmdshell|xp_logininfo|xp_enumgroups|xp_msver|xp_findnextmsg|xp_revokelogin|xp_grantlogin|xp_sprintf|xp_logevent|xp_sqlmaint|xp_loginconfig|xp_sscanf";
		system_table_list = "sysaltfiles|syslockinfo|syscacheobjects|syslogins|syscharsets|sysmessages|sysconfigures|sysoledbusers|syscurconfigs|sysperfinfo|sysdatabases|sysprocesses|sysdevices|sysremotelogins|syslanguages|sysservers|syscolumns|sysindexkeys|syscomments|sysmembers|sysconstraints|sysobjects|sysdepends|syspermissions|sysfilegroups|sysprotects|sysfiles|sysreferences|sysforeignkeys|systypes|sysfulltextcatalogs|sysusers|sysindexes|sysalerts|sysjobsteps|syscategories|sysnotifications|sysdownloadlist|sysoperators|sysjobhistory|systargetservergroupmembers|sysjobs|systargetservergroups|sysjobschedules|systargetservers|sysjobservers|systaskids|backupfile|restorefile|backupmediafamily|restorefilegroup|backupmediaset|restorehistory|backupset|sysdatabases|sysservers|sysreplicationalerts|MSagent_parameters|Mspublisher_databases|MSagent_profiles|MSreplication_objects|MSarticles|MSreplication_subscriptions|MSdistpublishers|MSrepl_commands|MSdistributiondbs|MSrepl_errors|MSdistribution_agents|MSrepl_originators|MSdistribution_history|MSrepl_transactions|MSdistributor|MSrepl_version|MSlogreader_agents|MSsnapshot_agents|MSlogreader_history|MSsnapshot_history|MSmerge_agents|MSsubscriber_info|MSmerge_history|MSsubscriber_schedule|MSmerge_subscriptions|MSsubscriptions|MSpublication_access|MSsubscription_properties|Mspublications|MSmerge_contents|sysmergearticles|MSmerge_delete_conflicts|sysmergepublications|MSmerge_genhistory|sysmergeschemachange|MSmerge_replinfo|sysmergesubscriptions|MSmerge_tombstone|sysmergesubsetfilters|sysarticles|syspublications|sysarticleupdates|syssubscriptions";
		system_function_list = "AVG|MAX|BINARY_CHECKSUM|MIN|CHECKSUM|SUM|CHECKSUM_AGG|STDEV|COUNT|STDEVP|COUNT_BIG|VAR|GROUPING|VARP|@@DATEFIRST|@@OPTIONS|@@DBTS|@@REMSERVER|@@LANGID|@@SERVERNAME|@@LANGUAGE|@@SERVICENAME|@@LOCK_TIMEOUT|@@SPID|@@MAX_CONNECTIONS|@@TEXTSIZE|@@MAX_PRECISION|@@VERSION|@@NESTLEVEL|@@CURSOR_ROWS|CURSOR_STATUS|@@FETCH_STATUS|DATEADD|DATEDIFF|DATENAME|DATEPART|DAY|GETDATE|GETUTCDATE|MONTH|YEAR|ABS|DEGREES|RAND|ACOS|EXP|ROUND|ASIN|FLOOR|SIGN|ATAN|LOG|SIN|ATN2|LOG10|SQUARE|CEILING|PI|SQRT|COS|POWER|TAN|COT|RADIANS|COL_LENGTH|fn_listextendedproperty|COL_NAME|FULLTEXTCATALOGPROPERTY|COLUMNPROPERTY|FULLTEXTSERVICEPROPERTY|DATABASEPROPERTY|INDEX_COL|DATABASEPROPERTYEX|INDEXKEY_PROPERTY|DB_ID|INDEXPROPERTY|DB_NAME|OBJECT_ID|FILE_ID|OBJECT_NAME|FILE_NAME|OBJECTPROPERTY|FILEGROUP_ID|@@PROCID|FILEGROUP_NAME|SQL_VARIANT_PROPERTY|FILEGROUPPROPERTY|TYPEPROPERTY|FILEPROPERTY|CONTAINSTABLE|FREETEXTTABLE|OPENDATASOURCE|OPENQUERY|OPENROWSET|OPENXML|fn_trace_geteventinfo|IS_SRVROLEMEMBER|fn_trace_getfilterinfo|SUSER_SID|fn_trace_getinfo|SUSER_SNAME|fn_trace_gettable|USER_ID|HAS_DBACCESS|USER|IS_MEMBER|ASCII|NCHAR|SOUNDEX|CHAR|PATINDEX|SPACE|CHARINDEX|REPLACE|STR|DIFFERENCE|QUOTENAME|STUFF|LEFT|REPLICATE|SUBSTRING|LEN|REVERSE|UNICODE|LOWER|RIGHT|UPPER|LTRIM|RTRIM|APP_NAME|CASE|expression|CAST|and|CONVERT|COALESCE|COLLATIONPROPERTY|CURRENT_TIMESTAMP|CURRENT_USER|DATALENGTH|@@ERROR|fn_helpcollations|fn_servershareddrives|fn_virtualfilestats|FORMATMESSAGE|GETANSINULL|HOST_ID|HOST_NAME|IDENT_CURRENT|IDENT_INCR|IDENT_SEED|@@IDENTITY|IDENTITY|(Function)|ISDATE|ISNULL|ISNUMERIC|NEWID|NULLIF|PARSENAME|PERMISSIONS|@@ROWCOUNT|ROWCOUNT_BIG|SCOPE_IDENTITY|SERVERPROPERTY|SESSIONPROPERTY|SESSION_USER|STATS_DATE|SYSTEM_USER|@@TRANCOUNT|USER_NAME|@@CONNECTIONS|@@PACK_RECEIVED|@@CPU_BUSY|@@PACK_SENT|fn_virtualfilestats|@@TIMETICKS|@@IDLE|@@TOTAL_ERRORS|@@IO_BUSY|@@TOTAL_READ|@@PACKET_ERRORS|@@TOTAL_WRITE|PATINDEX|TEXTPTR|TEXTVALID";
		datatype_list = "bigint|decimal|int|numeric|smallint|money|tinyint|smallmoney|bit|float|real|datetime|smalldatetime|char|text|varchar|nchar|ntext|nvarchar|binary|image|varbinary|cursor|timestamp|sql_variant|uniqueidentifier|table|xml";
		unformatted_reserved_word_list = "GO|dbo|ANSI_NULLS|QUOTED_IDENTIFIER|NOLOCK|OUTPUT|ROWLOCK|HOLDLOCK|NOCOUNT";
		
			// Create StringBuffer with an initial size of 4 times the original string.
			// This is to keep Java from continually having to grow the string.
			new_sql_string = createObject("java","java.lang.StringBuffer").init(javacast("int",len(sql_string)*4));
			this_formatted_token = createObject("java","java.lang.StringBuffer").init(javacast("int",50));
			this_token = createObject("java","java.lang.StringBuffer").init(javacast("int",25));
						
			lf = chr(10);
			cr = chr(13);
			crlf = cr & lf;
			
			// replace solitary line feed with a carriage return /  line feed combo
			sql_string = rereplacenocase(sql_string,"([^#cr#])#lf#","\1#crlf#","all");
			sql_string = rereplacenocase(sql_string,"([^#cr#])#lf#","\1#crlf#","all") & " ";
			iterations_to_complete = 0;
			
			// Loop until we are out of text
			while(len(sql_string))
				{
					// Used this for debugging
					// iterations_to_complete = iterations_to_complete + 1; 
					
					// find contiguous whitespace at the start of the string all at once
					// instead of one charater at a time in the main while loop.
					leading_whitespace = refindnocase("^[\s]+(?=\S)",sql_string,1,"yes");
					if(leading_whitespace.len[1])
						{
							this_token.append(mid(sql_string,leading_whitespace.pos[1],leading_whitespace.len[1]));
							this_formatted_token.append(this_token.toString());
						}
					// Multi-Line Comment
					else if(mid(sql_string,1,2) eq "/*")
						{
							nested_comment_stack = 1; // We are one comment deep
							pointer = 3; // Start searching immediatley after the opening comment
							// Look for end of comment block being mindful of nested comments
							while(nested_comment_stack and pointer LTE len(sql_string))
								{
									if(mid(sql_string,pointer,2) eq "/*")
										{
											nested_comment_stack = nested_comment_stack + 1; // We entered another level
										}
									else if(mid(sql_string,pointer,2) eq "*/")
										{
											nested_comment_stack = nested_comment_stack - 1; // We exited another level
										}
									pointer = pointer + 1;
								}
								if(nested_comment_stack)
									{
										end_of_comment_block = len(sql_string); // Something went wrong and we ran out of string before we found the ending comment
									}
								else
									{
										end_of_comment_block = pointer; // Pointer is already incremented one extra to allow for two character ending comment
									}

							this_token.append(mid(sql_string,1,end_of_comment_block));
							this_formatted_token.append("<span style=""color:").append(color_definition["Comment"]).append(";"">").append(this_token.toString()).append("</span>");
						}
					// One Line Comment
					else if(mid(sql_string,1,2) eq "--")
						{
							end_of_line = findnocase(crlf,sql_string,3)+1;
							if(not end_of_line-1)
								{
									end_of_line = len(sql_string);
								}
							this_token.append(mid(sql_string,1,end_of_line));
							this_formatted_token.append("<span style=""color:").append(color_definition["Comment"]).append(";"">").append(this_token.toString()).append("</span>");
						}
					// Character String
					else if(mid(sql_string,1,1) eq "'")
						{
							end_of_string = findnocase("'",sql_string,2);
							if(not end_of_string)
								{
									end_of_string = len(sql_string);
								}
							this_token.append(mid(sql_string,1,end_of_string));
							this_formatted_token.append("<span style=""color:").append(color_definition["Character string"]).append(";"">").append(this_token.toString()).append("</span>");
						}
					// Operator
					else if(listfindnocase(operator_list,mid(sql_string,1,1),"|"))
						{
							this_token.append(mid(sql_string,1,1));
							this_formatted_token.append("<span style=""color:").append(color_definition["Operator"]).append(";"">").append(this_token.toString()).append("</span>");
						}
					else
						{
							// See if there is a word next
							// This may need some work.  I want to find one or more alphanumeric characters plus @ and _
							// at the beginning of the string followed by punctution or whitespace with the exception of @ and _
							// This should catch things like: 
							// SET, ANSI_NULLS, varchar, @executer_entity_id, uniqueidentifier,
							// service_item_type_id, 255, NEWID, NULL, f_date_calc, @@ERROR, sp_executesql
							
							
							search_for_word = refindnocase("^[[:alpha:][:digit:]##@_]+(?=[[:punct:][:space:]^@^_])",sql_string,1,"yes");
							if(search_for_word.len[1])
								{	
									this_token.append(mid(sql_string,search_for_word.pos[1],search_for_word.len[1]));
									
									// I fear the performance of comparing my token to the "monster lists" so I will weed out as much as possible
									// For performance, catch any numbers, temp tables, table variables and non-colored reserved words here
									if(isnumeric(this_token.toString()) or listfindnocase(unformatted_reserved_word_list,this_token.toString(),"|") or refindnocase("^##{1,2}|[@].*",this_token.toString()))
										{
											this_formatted_token.append(this_token.toString());
										}
									// Reserved word
									else if(listfindnocase(reserved_word_list,this_token.toString(),"|") or listfindnocase(datatype_list,this_token.toString(),"|"))
										{
											this_formatted_token.append("<span style=""color:").append(color_definition["Keyword"]).append(";"">").append(this_token.toString()).append("</span>");
										}
									// system function
									else if(listfindnocase(system_function_list,this_token.toString(),"|"))
										{
											this_formatted_token.append("<span style=""color:").append(color_definition["System Function"]).append(";"">").append(this_token.toString()).append("</span>");
										}
									// System Table
									else if(listfindnocase(system_table_list,this_token.toString(),"|"))
										{
											this_formatted_token.append("<span style=""color:").append(color_definition["System Table"]).append(";"">").append(this_token.toString()).append("</span>");
										}
									// System Stored Proc
									else if(listfindnocase(system_stored_proc_list,this_token.toString(),"|"))
										{
											this_formatted_token.append("<span style=""color:").append(color_definition["Stored Procedure"]).append(";"">").append(this_token.toString()).append("</span>");
										}
									// unknown word
									// These should be numbers, user tables, columns, user variables, table variables, and temp tables.
									else
										{
											this_formatted_token.append(this_token.toString());
										}
								}
							// Catch all-- [ ] # 
							else
								{
									this_token.append(mid(sql_string,1,1));
									this_formatted_token.append(this_token.toString());
								}
						}
					// Keep building the new string.
					new_sql_string.append(this_formatted_token.toString());
					// Keep slicing off the old string
					sql_string = mid(sql_string,len(this_token.toString())+1,len(sql_string));
					// Empty the StringBuffers
					this_formatted_token.delete(0,this_formatted_token.length());
					this_token.delete(0,this_token.length());
				}
			
			string_to_return = new_sql_string.toString();
			// For html display purposes, but in <br> tags and &nbsp;.
			string_to_return = replacenocase(string_to_return,crlf,"<br>#crlf#","all");
			string_to_return = replacenocase(string_to_return,"	","&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;","all");
			string_to_return = "<span style=""font-family : 'Courier New'; font-size: 8pt"">" & string_to_return & "</span>";
			// Stick a fork in it it's done.
			//writeoutput(iterations_to_complete & " iterations<br>");
			return string_to_return;
		}
				
</cfscript>
