<cfinclude template="sql_color_code.cfm">

<cfset sql_string = "set ANSI_NULLS ON
set QUOTED_IDENTIFIER ON
go

/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Name:			ps_report_commitment_sent
Created by:		JPG
Date:			10/18/2005

Purpose: Used to generate NLS Closing website Commitment Sent report

Inputs/Outputs
===============================================================================================
Inputs: (Required all Options) executer_entity_id, option, id

Opt	Required Input		Optional Inputs:					Outputs:
===============================================================================================

Modification History
===============================================================================================
Rev ##		Initials		Date			Purpose
===============================================================================================
##001		JPG		10/18/2005		Create
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

ALTER PROCEDURE [dbo].[ps_report_commitment_sent]
  @reporting_entity_id	uniqueidentifier,
  @entity_id_customer uniqueidentifier,
  @start_date datetime=NULL,
  @end_date datetime=NULL
AS 

BEGIN
SET NOCOUNT ON

DECLARE @colorder varchar(4000)
DECLARE @service_item_id_title uniqueidentifier

SELECT @service_item_id_title = service_item_id
FROM service_item WITH(NOLOCK)
WHERE service_item_dictionary_id = '525FE75C-CBE9-4A64-B2BC-9CE0D8EDDB37' --TITLE
AND entity_id = @reporting_entity_id

SET @colorder = 'Order##|loan##|date_ordered|loan_officer|buyer|state|status'

SELECT DISTINCT dbo.f_return_hot_link('ORDER', ob.ORDER_ID, 0, '') AS a_nls_order_num, 
	ol.loan_number as b_loan_number,
	ob.datetime_created as c_date_ordered, 
	RTRIM(ISNULL(voelo.full_name,'No Loan Officer Specified'))as d_loan_officer,
	RTRIM(ISNULL(voeb.full_name,'No Buyer Specified')) AS e_buyer,
	RTRIM(ISNULL(ob.state,'')) as f_state,
	RTRIM(ISNULL(op.product_last_status_description,'')) as g_status,
	@colorder AS _colorder,
 	1 AS _mapfields
FROM order_basic ob WITH(NOLOCK)
LEFT OUTER JOIN v_order_entity_simple voelo WITH(NOLOCK) ON ob.order_id = voelo.order_id 
  	AND voelo.u_id_order_entity_type = '66CB46AE-8FEA-493B-991D-313ADFB1E609' --'Loan Officer'
  	AND voelo.sort_order = 1
  	AND voelo.system_status = 1	
INNER JOIN v_order_entity_simple voeb WITH(NOLOCK) ON ob.order_id = voeb.order_id 
  	AND voeb.u_id_order_entity_type = 'FCD315BB-89D9-4742-94D5-2CDDEEF3095F' --'Borrower'
  	AND voeb.sort_order = 1
  	AND voeb.system_status = 1	
LEFT OUTER JOIN v_order_entity_simple voelh WITH(NOLOCK) ON ob.order_id = voelh.order_id 
  	AND voelh.u_id_order_entity_type = '50C6A9D3-0BDC-4F4D-99D9-FC29BD02AEBA' --'LENDER'
  	AND voelh.sort_order = 1
  	AND voelh.system_status = 1	
LEFT OUTER JOIN order_loan ol WITH(NOLOCK) ON ol.order_entity_id = voelh.order_entity_id --'LOAN NUMBER'
	AND item_sort = 1
INNER JOIN order_product op WITH(NOLOCK) ON op.order_id = ob.order_id 
	AND service_service_item_id = @service_item_id_title
INNER JOIN milestone m WITH(NOLOCK) ON m.order_product_id = op.order_product_id 
	AND col_position_4 IS NOT NULL
WHERE ob.entity_id_customer = @entity_id_customer
	AND DATEDIFF(d,@start_date,ob.datetime_created)>=0
	AND DATEDIFF(d,ob.datetime_created,@end_date)>=0
	AND ob.entity_id_order_company = @reporting_entity_id
ORDER BY c_date_ordered, g_status
END">



<cfoutput>
 	#sql_color_code(sql_string)#
</cfoutput>
